/* removeDiv plugin for CKEditor
 *
 * Plugin name:      removediv
 * Menu button name: RemoveDiv
 *
 *
 * @author Mladen Stankovic
 * @version 0.5
 */

(function()
{
  CKEDITOR.plugins.add( 'removediv',
    {
      init : function( editor )
      {
        editor.addCommand( 'removediv',
          {
            exec : function( editor )
            {
              var selection = editor.getSelection(),
                ranges = selection && selection.getRanges(),
                range,
                bookmarks = selection.createBookmarks(),
                walker,
                toRemove = [];

              function findDiv( node )
              {
                var path = new CKEDITOR.dom.elementPath( node ),
                  blockLimit = path.blockLimit,
                  div = blockLimit.is( 'div' ) && blockLimit;

                if ( div && !div.data( 'cke-div-added' ) )
                {
                  toRemove.push( div );
                  div.data( 'cke-div-added' );
                }
              }

              for ( var i = 0 ; i < ranges.length ; i++ )
              {
                range = ranges[ i ];
                if ( range.collapsed )
                  findDiv( selection.getStartElement() );
                else
                {
                  walker = new CKEDITOR.dom.walker( range );
                  walker.evaluator = findDiv;
                  walker.lastForward();
                }
              }

              for ( i = 0 ; i < toRemove.length ; i++ )
                toRemove[ i ].remove( true );

              selection.selectBookmarks( bookmarks );
            }
          } );

        editor.ui.addButton( 'RemoveDiv',
          {
            label : 'Remove Div',
            command :'removediv',
            toolbar: 'div',
            icon: this.path + '../../../icons/eraser.svg'
          } );
      }
    } );
})();
