<?php

namespace Drupal\ckeditor_remove_div\Plugin\CKEditorPlugin;

use Drupal\ckeditor\CKEditorPluginBase;
use Drupal\editor\Entity\Editor;

/**
 * Defines the "removediv" plugin.
 *
 * @CKEditorPlugin(
 *   id = "removediv",
 *   label = @Translation("Remove Div")
 * )
 */
class CKEditorRemoveDiv extends CKEditorPluginBase {

  protected string $modulePath;

  public function __construct(array $configuration, $plugin_id, $plugin_definition) {
    parent::__construct($configuration, $plugin_id, $plugin_definition);
    $this->modulePath = \Drupal::service('extension.path.resolver')
      ->getPath('module', 'ckeditor_remove_div');
  }

  /**
   * {@inheritdoc}
   */
  public function getFile() {
    return $this->modulePath . '/js/plugins/removediv/plugin.js';
  }

  /**
   * {@inheritdoc}
   */
  public function getButtons() {
    return [
      'RemoveDiv' => [
        'label' => $this->t('Remove Div'),
        'image' => $this->modulePath . '/icons/eraser.svg',
      ],
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getConfig(Editor $editor) {
    return [];
  }

}
